// ignore_for_file: non_constant_identifier_names

import 'package:universal_io/io.dart';
import "package:path/path.dart" as path;

class Pub {
  Directory get base_directory {
    String? configDir;
    if (Platform.isLinux) {
      configDir = path.join(
          Platform.environment['XDG_CONFIG_HOME'] ??
              Platform.environment['HOME']!,
          '.pub-cache');
    } else if (Platform.isWindows) {
      configDir = Platform.environment['APPDATA']!;
    } else if (Platform.isMacOS) {
      configDir = path.join(
          Platform.environment['HOME']!, 'Library', 'Application Support');
    } else {
      configDir = path.join(Platform.environment['HOME'] ?? '', '.pub-cache');
    }
    return Directory(configDir);
  }

  Directory get bin_directory {
    return Directory(path.join(base_directory.path, "bin"));
  }

  Directory get git_directory {
    return Directory(path.join(base_directory.path, "git"));
  }

  Directory get global_packages_directory {
    return Directory(path.join(base_directory.path, "global_packages"));
  }

  Directory get hosted_directory {
    return Directory(path.join(base_directory.path, "hosted"));
  }

  Directory get hosted_hashes_directory {
    return Directory(path.join(base_directory.path, "hosted-hashes"));
  }

  Directory get temp_directory {
    return Directory(path.join(base_directory.path, "_temp"));
  }
}
