import 'dart:convert';

extension DynamicDataFutureExtension on Future<dynamic> {
  Future<String> toStringifyPretty([int space = 4]) async {
    dynamic data_ = await this;
    if (data_ is Map || data_ is List) {
      return JsonEncoder.withIndent(" " * space).convert(data_);
    } else {
      return data_.toString();
    }
  }

  Future<void> printPretty([int space = 4]) async {
    dynamic data_ = await this;
    if (data_ is Map || data_ is List) {
      print(JsonEncoder.withIndent(" " * space).convert(data_));
    } else {
      print(data_.toString());
    }
  }
}

extension DynamicDataExtension on dynamic {
  String toStringifyPretty([int space = 4]) {
    if (this is Map || this is List) {
      return JsonEncoder.withIndent(" " * space).convert(this);
    } else {
      return toString();
    }
  }

  void printPretty([int space = 4]) {
    if (this is Map || this is List) {
      print(toStringifyPretty(space));
    } else {
      print(toString());
    }
  }
}
