// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

class CaptchaWord extends JsonDart {
  CaptchaWord(super.rawData);

  static Map get defaultData {
    return {
      "@type": "captchaWord",
      "answer": [3, 5, 3],
      "words": ["satu", "dua", "tiga", "empat", "lima", "enam", "tujuh"]
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  List<int> get answer {
    try {
      if (rawData["answer"] is List == false) {
        return [];
      }
      return (rawData["answer"] as List).cast<int>();
    } catch (e) {
      return [];
    }
  }

  List<String> get words {
    try {
      if (rawData["words"] is List == false) {
        return [];
      }
      return (rawData["words"] as List).cast<String>();
    } catch (e) {
      return [];
    }
  }

  static CaptchaWord create({
    String? special_type,
    List<int>? answer,
    List<String>? words,
  }) {
    CaptchaWord captchaWord = CaptchaWord({
      "@type": special_type,
      "answer": answer,
      "words": words,
    });

    return captchaWord;
  }
}
