import 'dart:convert';

class SizeAspectRatio {
  int width;
  int height;
  SizeAspectRatio({
    required this.width,
    required this.height,
  });

  factory SizeAspectRatio.resize(
    int width,
    int height,
    int maxWidth,
    int maxHeight,
  ) {
    double scaleFactor = (maxWidth / width > maxHeight / height)
        ? maxHeight / height
        : maxWidth / width;
    int newWidth = (width * scaleFactor).round();
    int newHeight = (height * scaleFactor).round();
    int finalWidth = newWidth.clamp(0, maxWidth);
    int finalHeight = newHeight.clamp(0, maxHeight);
    return SizeAspectRatio(
      width: finalWidth,
      height: finalHeight,
    );
  }

  SizeAspectRatio resize(
    int maxWidth,
    int maxHeight,
  ) {
    double scaleFactor = (maxWidth / width > maxHeight / height)
        ? maxHeight / height
        : maxWidth / width;
    int newWidth = (width * scaleFactor).round();
    int newHeight = (height * scaleFactor).round();
    int finalWidth = newWidth.clamp(0, maxWidth);
    int finalHeight = newHeight.clamp(0, maxHeight);
    return SizeAspectRatio(
      width: finalWidth,
      height: finalHeight,
    );
  }

  void operator []=(key, value) {
    if (key == "width") {
      width = value;
    }
    if (key == "height") {
      height = value;
    }
    return;
  }

  int? operator [](key) {
    if (key == "width") {
      return width;
    }
    if (key == "height") {
      return height;
    }
    return null;
  }

  @override
  String toString() {
    return json.encode({
      "@type": runtimeType.toString(),
      "height": height,
      "width": width,
    });
  }
}
