// ignore_for_file: unnecessary_brace_in_string_interps, non_constant_identifier_names
//

Future<Map> jsonEach({
  required Map data,
  required Future<dynamic> Function(
          dynamic key, dynamic value, bool isList, bool isMapInList)
      builder,
}) async {
  Map jsonData = {};

  for (var element in data.entries) {
    dynamic key = element.key;
    dynamic value = element.value;

    if (value is Map) {
      jsonData[key] = await jsonEach(data: value, builder: builder);
    } else if (value is List) {
      jsonData[key] =
          await jsonListEach(key: key, data: value, builder: builder);
    } else {
      jsonData[key] = await builder(key, value, false, false);
    }
  }

  return jsonData;
}

Future<List> jsonListEach({
  required String key,
  required List data,
  required Future<dynamic> Function(
          dynamic key, dynamic value, bool isList, bool isMapInList)
      builder,
}) async {
  List new_data = [];
  for (var e in data) {
    if (e is Map) {
      new_data.add(await jsonEach(data: e, builder: builder));
    } else if (e is List) {
      new_data.add(await jsonListEach(key: key, data: e, builder: builder));
    } else {
      new_data.add(await builder(key, e, true, false));
    }
  }

  return new_data;
}
