// ignore_for_file: non_constant_identifier_names

import 'package:universal_io/io.dart';

class TcpSocketServer {
  late ServerSocket server;
  late SecureServerSocket server_secure;

  TcpSocketServer();
  Future<ServerSocket> listen({
    required String host,
    required int port,
    required void Function(Socket socket) onData,
    Function? onError,
    void Function()? onDone,
    bool? cancelOnError,
    int backlog = 0,
    bool v6Only = false,
    bool shared = true,
  }) async {
    server = await ServerSocket.bind(
      host,
      port,
      backlog: backlog,
      v6Only: v6Only,
      shared: shared,
    );
    server.listen(
      onData,
      onDone: onDone,
      onError: onError,
      cancelOnError: cancelOnError,
    );
    return server;
  }

  Future<SecureServerSocket> listenSecure({
    required String host,
    required int port,
    SecurityContext? context,
    required void Function(SecureSocket secureSocket) onData,
    Function? onError,
    void Function()? onDone,
    bool cancelOnError = true,
    int backlog = 0,
    bool v6Only = false,
    bool requestClientCertificate = false,
    bool requireClientCertificate = false,
    List<String>? supportedProtocols,
    bool shared = true,
  }) async {
    server_secure = await SecureServerSocket.bind(
      host,
      port,
      context,
      backlog: backlog,
      v6Only: v6Only,
      requestClientCertificate: requestClientCertificate,
      requireClientCertificate: requireClientCertificate,
      supportedProtocols: supportedProtocols,
      shared: shared,
    );

    server_secure.listen(
      onData,
      onDone: onDone,
      onError: onError,
      cancelOnError: cancelOnError,
    );
    return server_secure;
  }
}
